"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resolvePath = void 0;

var _resolveSearchParams = require("./resolveSearchParams");

var _resolvePathParams = require("./resolvePathParams");

var resolvePath = function resolvePath(_ref) {
  var path = _ref.path,
      pathParams = _ref.pathParams,
      searchParams = _ref.searchParams;
  var resolvedPathParams = pathParams ? (0, _resolvePathParams.resolvePathParams)({
    path: path,
    pathParams: pathParams
  }) : path;
  var resolvedSearchParams = searchParams ? "?".concat((0, _resolveSearchParams.resolveSearchParams)({
    searchParams: searchParams
  })) : '';
  return "".concat(resolvedPathParams).concat(resolvedSearchParams);
};

exports.resolvePath = resolvePath;