"use strict";

var _resolvePathParams = require("./resolvePathParams");

describe('resolvePathParams', function () {
  it.each([[{
    path: 'hello/:id',
    pathParams: {
      id: 123
    }
  }, 'hello/123'], [{
    path: 'hello/:id/users/:id',
    pathParams: {
      id: 123
    }
  }, 'hello/123/users/123'], [{
    path: 'hello/:id/users/:userId/accounts/:accountId',
    pathParams: {
      id: 123,
      userId: 'abc',
      accountId: null
    }
  }, 'hello/123/users/abc/accounts/null']])('with the object %s returns: %s', function (value, expected) {
    var result = (0, _resolvePathParams.resolvePathParams)(value);
    expect(result).toEqual(expected);
  });
});