var _excluded = ["searchParams", "pathParams"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import qs from 'query-string';
import React from 'react';
import { Link, Route, useLocation, useParams } from 'react-router-dom';
import { resolvePath as _resolvePath } from './utils/resolvePath';
/**
 * Return typed path params
 */

var defineUseRouteParams = () => () => useParams();
/**
 * Return default useLocation from react-router-dom
 */


var defineUseRouteLocation = () => () => useLocation();
/**
 * Return typed and parsed search params URL
 */


var defineUseRouteSearch = () => () => {
  var {
    search
  } = useLocation();
  return qs.parse(search);
};
/**
 * Wrapper on top of Route, prevent passing the path manually
 */


function withRoutePath(_ref) {
  var {
    path
  } = _ref;
  return props => {
    return /*#__PURE__*/React.createElement(Route, _extends({
      path: path
    }, props), props.children);
  };
}
/**
 * Wrapper on top of Link, handle typesafe link with searchParams and pathParams
 */


function withLinkPath(_ref2) {
  var {
    path
  } = _ref2;
  return props => {
    var {
      searchParams,
      pathParams
    } = props,
        restProps = _objectWithoutProperties(props, _excluded);

    var resolvedPath = _resolvePath({
      path,
      pathParams,
      searchParams
    });

    return /*#__PURE__*/React.createElement(Link, _extends({
      to: resolvedPath
    }, restProps), props.children);
  };
}

export var defineRoute = routeOptions => {
  var currentPath = routeOptions.path;
  return {
    path: routeOptions.path,
    resolvePath: _ref3 => {
      var {
        searchParams,
        pathParams
      } = _ref3;
      return _resolvePath({
        searchParams,
        pathParams,
        path: routeOptions.path
      });
    },
    useParams: defineUseRouteParams(),
    useLocation: defineUseRouteLocation(),
    useSearch: defineUseRouteSearch(),
    Route: withRoutePath({
      path: currentPath
    }),
    Link: withLinkPath({
      path: currentPath
    })
  };
};