import { resolvePath } from './resolvePath';
describe('resolvePath', () => {
  it.each([[{
    path: 'hello/:id',
    pathParams: {
      id: 123
    },
    searchParams: {
      date: 'today'
    }
  }, 'hello/123?date=today'], [{
    path: 'hello/:id',
    pathParams: {
      id: 123
    },
    searchParams: {
      date: 'today',
      user: 0
    }
  }, 'hello/123?date=today&user=0'], [{
    path: 'hello/:id',
    pathParams: {
      id: 123
    }
  }, 'hello/123'], [{
    path: 'hello/yo',
    pathParams: {
      id: 123
    }
  }, 'hello/yo'], [{
    path: 'hello/yo'
  }, 'hello/yo'], [{
    path: 'hello/yo',
    searchParams: {
      date: 'today'
    }
  }, 'hello/yo?date=today']])('with the object %s returns: %s', (value, expected) => {
    var result = resolvePath(value);
    expect(result).toEqual(expected);
  });
});