/// <reference types="react" />
import { LinkProps, RouteProps } from 'react-router-dom';
import { RouteDefinition, RoutePathParamsKeys, RouteSearchParams, RoutePathParams } from './types';
declare type DefineRouteParams = {
    path: string;
};
export declare const defineRoute: <T extends RouteDefinition>(routeOptions: DefineRouteParams) => {
    path: string;
    resolvePath: ({ searchParams, pathParams }: T) => string;
    useParams: () => Readonly<[RoutePathParamsKeys<T>] extends [string] ? import("react-router").Params<RoutePathParamsKeys<T>> : Partial<RoutePathParamsKeys<T>>>;
    useLocation: () => import("history").Location;
    useSearch: () => RouteSearchParams<T>;
    Route: (props: Omit<RouteProps, 'path'>) => JSX.Element;
    Link: (props: Omit<LinkProps & {
        searchParams?: RouteSearchParams<T> | undefined;
        pathParams?: RoutePathParams<T> | undefined;
    }, "to">) => JSX.Element;
};
export {};
