import { defineRoute } from './defineRoute';
export declare type DefineRoute = ReturnType<typeof defineRoute>;
export declare type RoutesConfig = {
    [key: string]: DefineRoute;
};
export declare type RouterConfig = {
    routes: RoutesConfig;
};
export declare type ReturnsRoutesConfig<T extends RouterConfig> = {
    routes: {
        [key in keyof T['routes']]: DefineRoute;
    };
};
export declare function defineRouterConfig<T extends RouterConfig>(options: T): ReturnsRoutesConfig<T>;
